from random import randrange as rrng

## puts an integer value into byte-safe [0, 255] margins
def byteSafe(arg):
		if (arg > 255):
			return 255
		if (arg < 0):
			return 0
		return arg

## main corruption process
def mainProcess(nameSource, nameDest, parameters):

	##======== create handles - open source, create/open destination
	handleSource = open(nameSource, 'rb')
	handleDest = open(nameDest, "wb")

	##======== local variables dragged from parameters dictionary
	optPreserveHead  = parameters[0]   
	optByteplaceOn   = parameters[1]+2
	optReplaceFreq   = parameters[2]
	optReplaceVal    = parameters[3]
	optSwapperOn     = parameters[4]+2
	optSwapperFreq   = parameters[5]
	optRchunkOn      = parameters[6]+2
	optRchunkCycle   = parameters[7]
	otpRchunkActive  = parameters[8]
	optAdderOn       = parameters[9]+2
	optAdderFreq     = parameters[10]
	optAdderValue    = parameters[11]
	optRandplaceOn   = parameters[12]+2
	optRandplaceFreq = parameters[13]
	optShifterOn     = parameters[14]+2
	optShifterFreq   = parameters[15]
	optShifterDir    = parameters[16]

	##======== timers initialize
	timerByteplace = optReplaceFreq
	timerSwapper = optSwapperFreq
	timerRchunk = optRchunkCycle
	timerAdder = optAdderFreq
	timerRandplace = optRandplaceFreq
	timerShifter = optShifterFreq

	##======== actual corruption
	byteCount = 0
	try:
		while (1):
			##========  read new original byte, if it is null -- break out of while 1 cycle
			byte = handleSource.read(1)
			if not byte:
				break
			byteCount += 1

			if (not byteCount < optPreserveHead):

				##======== decrement all timers
				timerByteplace -= 1
				timerSwapper -= 1
				timerRchunk -= 1
				timerAdder -= 1
				timerRandplace -= 1
				timerShifter -= 1

				##======== process the original byte with corruptors
				## random chunker routine in active cycle
				if (timerRchunk < otpRchunkActive):
					if (optRchunkOn == 1):
						rchVal = rrng(256);
						byte = bytes(bytes([rchVal]))

				## random chunker routine on timer
				if (timerRchunk == 0):
					timerRchunk = optRchunkCycle

				## randplace routine on timer
				if (timerRandplace == 0):
					timerRandplace = optRandplaceFreq
					if (optRandplaceOn == 1):
						rchVal = rrng(256);
						byte = bytes(bytes([rchVal]))

				## adder routine on timer
				if (timerAdder == 0):
					timerAdder = optAdderFreq
					if (optAdderOn == 1):
						byte = int.from_bytes(byte, "little")
						byte += optAdderValue
						byte = bytes([byteSafe(byte)])

				## byteplace routine on timer
				if (timerByteplace == 0):
					timerByteplace = optReplaceFreq
					if (optByteplaceOn == 1):
						byte = bytes([optReplaceVal])

				## swapper routine on timer
				if (timerSwapper == 0):
					timerSwapper = optSwapperFreq
					if (optSwapperOn == 1):
						swapByte = handleSource.read(1)
						handleDest.write(swapByte)

				## shifter routine on timer
				if (timerShifter == 0):
					timerShifter = optShifterFreq
					if (optShifterOn == 1):
						byte = int.from_bytes(byte, "little")
						if (optShifterDir == 0):
							# shift left
							byte <<= 1
						else:
							# shift right
							byte >>= 1
						byte = bytes([byteSafe(byte)])

			##======== write the resulting byte into the destination file
			handleDest.write(byte)

	finally:

		##======== close everything
		handleSource.close()
		handleDest.close()